new kernel not installed during upgrade if linux meta package not installed

Bug #1509305 reported by zob on 2015-10-23
42
This bug affects 7 people
Affects Status Importance Assigned to Milestone
ubuntu-release-upgrader (Ubuntu)
High
Brian Murray
Wily
High
Brian Murray

Bug Description

Test Case
---------
1) Remove the linux-generic package as software-properties does LP: #1506169
2) upgrade from vivid to wily and reboot
3) observe that you are still running the vivid (3.19.0) kernel

One could also confirm that linux-image-4.2.0-16.19-generic was removed (see /var/log/dist-upgrade/main.log) instead of rebooting.

With the version of the release upgrader from -proposed this will not happen.

Original Description
--------------------------------------------------------------

Could someone confirm if this is a duplicate of bug nr. 1508157

I have the exact same issue and precondition to my knowledge.

I too had nvidia propiertary drivers installed:
nvidia-settings -q NvidiaDriverVersion

  Attribute 'NvidiaDriverVersion' (ubu1504desk:0.0): 352.41
  Attribute 'NvidiaDriverVersion' (ubu1504desk:0[gpu:0]): 352.41

Upgrading from Vivid -> Wily the package linux-image-generic seem to get uninstalled. I end up with a kernel beeing the same as the one I had just before the upgrade ("ingen" is danish for "none" - should have changed the language):

apt-cache policy linux-image-generic
linux-image-generic:
  Installeret: (ingen)
  Kandidat: 4.2.0.16.18
  Versionstabel:
     4.2.0.16.18 0
        500 http://archive.ubuntu.com/ubuntu/ wily/main amd64 Packages

cat /etc/issue && uname -a
Ubuntu 15.10 \n \l

Linux ubu1504desk 3.19.0-21-generic #21-Ubuntu SMP Sun Jun 14 18:31:11 UTC 2015 x86_64 x86_64 x86_64 GNU/Linux

I have to add that when I ran ubuntu-bug ubuntu-release-upgrader-core to report this bug I had installed the package linux-image-generic in the meantime. So you will see that I'm on that kernel now, but I had to install it manually.

ProblemType: BugDistroRelease: Ubuntu 15.10
Package: ubuntu-release-upgrader-core 1:15.10.14
ProcVersionSignature: Ubuntu 4.2.0-16.19-generic 4.2.3
Uname: Linux 4.2.0-16-generic x86_64
NonfreeKernelModules: nvidia
ApportVersion: 2.19.1-0ubuntu3
Architecture: amd64
CrashDB: ubuntu
CurrentDesktop: Unity
Date: Fri Oct 23 12:35:20 2015
InstallationDate: Installed on 2015-06-20 (124 days ago)
InstallationMedia: Ubuntu 15.04 "Vivid Vervet" - Release amd64 (20150422)
PackageArchitecture: allSourcePackage: ubuntu-release-upgrader
UpgradeStatus: Upgraded to wily on 2015-10-22 (0 days ago)
VarLogDistupgradeTermlog:

Related branches

zob (zob) wrote :
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in ubuntu-release-upgrader (Ubuntu):
status: New → Confirmed
pabo (pb-prontonet) wrote :

 $ lsb_release -a
No LSB modules are available.
Distributor ID: Ubuntu
Description: Ubuntu 15.10
Release: 15.10
Codename: wily

$ cat /proc/version
Linux version 3.19.0-30-generic (buildd@lcy01-14) (gcc version 4.9.2 (Ubuntu 4.9.2-10ubuntu13) ) #34-Ubuntu SMP Fri Oct 2 22:08:41 UTC 2015

Brian Murray (brian-murray) wrote :

Looking at your VarLogDistupgradeAptclonesystemstate.tar.gz you never had linux-image-generic installed before the upgrade:

2244 linux-firmware 1.143.3 1
2245 linux-headers-3.19.0-15 3.19.0-15.15 1
2246 linux-headers-3.19.0-15-generic 3.19.0-15.15 1
2247 linux-headers-3.19.0-21 3.19.0-21.21 1
2248 linux-headers-3.19.0-21-generic 3.19.0-21.21 1
2249 linux-image-3.19.0-15-generic 3.19.0-15.15 1
2250 linux-image-3.19.0-21-generic 3.19.0-21.21 1
2251 linux-image-extra-3.19.0-15-generic 3.19.0-15.15 1
2252 linux-image-extra-3.19.0-21-generic 3.19.0-21.21 1

The fact that linux-generic was not installed was likely due to bug 1506169.

Brian Murray (brian-murray) wrote :

I've recreated this by removing linux-generic and then running sudo apt-get autoremove. I then upgraded from Vivid to Wily and the kernel was not updated.

Changed in ubuntu-release-upgrader (Ubuntu):
importance: Undecided → High
status: Confirmed → Triaged
summary: - Kernel not upgraded during upgrade from Vivid to Wily
+ Kernel not upgraded during upgrade from Vivid to Wily if linux-generic
+ not installed

I see. Nice catch Brian. Thanks.
Shouldn't this bug report be closed then?

zob (zob) wrote :

Of course, it could be argued, that ubuntu-release-upgrader should double check if linux-image-generic is installed.
It is kind of essential, but maybe it should be possible to upgrade without getting the latest kernel?

Ubuntu QA Website (ubuntuqa) wrote :

This bug has been reported on the Ubuntu ISO testing tracker.

A list of all reports related to this bug can be found here:
http://iso.qa.ubuntu.com/qatracker/reports/bugs/1509305

tags: added: iso-testing
summary: - Kernel not upgraded during upgrade from Vivid to Wily if linux-generic
- not installed
+ wily kernel removed after upgrade if linux meta package not installed
Changed in ubuntu-release-upgrader (Ubuntu):
assignee: nobody → Brian Murray (brian-murray)
status: Triaged → In Progress
Changed in ubuntu-release-upgrader (Ubuntu Wily):
status: New → Triaged
importance: Undecided → High

This bug was fixed in the package ubuntu-release-upgrader - 1:16.04.1

---------------
ubuntu-release-upgrader (1:16.04.1) xenial; urgency=medium

  [ Barry Warsaw ]
  * Don't try to import janitor and NvidiaDetector in a package relative
    to this one, to avoid the possibility of dangling symlinks when the
    packages actually containing these modules is not installed.
    (LP: #1485093)
  * debian/python3-distupgrade.links: Removed.

  [ Brian Murray ]
  * DistUpgrade/{EOL,}ReleaseAnnouncement,
    DistUpgrade/DistUpgrade/window_main.ui,
    data/gtkbuilder/DistUpgrade.ui,
    data/DistUpgrade.cfg,
    data/DistUpgrade.cfg.trusty,
    pre-build.sh:
    - updated for 15.10->16.04
  * DistUpgrade/DistUpgradeQuirks.py: add in a quirk to ensure that a linux
    metapackage is installed after the release upgrade. (LP: #1509305)

  [ Michael Vogt ]
  * DistUpgrade/DistUpgradeQuirks.py: improve linux metapackage check and add
    a test for it.

 -- Brian Murray <email address hidden> Tue, 27 Oct 2015 13:45:19 -0700

Changed in ubuntu-release-upgrader (Ubuntu):
status: In Progress → Fix Released
summary: - wily kernel removed after upgrade if linux meta package not installed
+ new kernel removed after upgrade if linux meta package not installed

Hello zob, or anyone else affected,

Accepted ubuntu-release-upgrader into wily-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/ubuntu-release-upgrader/1:15.10.14.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in ubuntu-release-upgrader (Ubuntu Wily):
status: Triaged → Fix Committed
tags: added: verification-needed
description: updated
Changed in ubuntu-release-upgrader (Ubuntu Wily):
assignee: nobody → Brian Murray (brian-murray)

I tested an upgrade from Vivid to Wily using the release upgrader in -proposed with the following results:

2015-10-27 17:57:09,161 INFO Using config files '['./DistUpgrade.cfg']'
2015-10-27 17:57:09,161 INFO uname information: 'Linux clean-vivid-amd64 3.19.0-30-generic #34-Ubuntu SMP Fri Oct 2 22:08:41 UTC 2015 x86_64'
2015-10-27 17:57:09,161 INFO apt version: '1.0.9.7ubuntu4'
2015-10-27 17:57:09,161 INFO python version: '3.4.3 (default, Mar 26 2015, 22:03:40)
[GCC 4.9.2]'
2015-10-27 17:57:09,161 INFO release-upgrader version '15.10.14.1' started
...
2015-10-27 17:57:35,639 DEBUG quirks: running wilyPostDistUpgradeCache
2015-10-27 17:57:36,300 DEBUG Comparing 3.19.0-15 with
2015-10-27 17:57:36,301 DEBUG Comparing 3.19.0-30 with 3.19.0-15
2015-10-27 17:57:36,302 DEBUG Comparing 4.2.0-16 with 3.19.0-30
2015-10-27 17:57:36,711 INFO installing linux metapackage: linux-generic
2015-10-27 17:57:36,712 DEBUG Installing 'linux-generic' (linux metapackage may have been accidentally uninstalled)

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-release-upgrader - 1:15.10.14.1

---------------
ubuntu-release-upgrader (1:15.10.14.1) wily-proposed; urgency=medium

  * DistUpgrade/DistUpgradeQuirks.py: add in a quirk to ensure that a linux
    metapackage is installed after the release upgrade. (LP: #1509305)

 -- Brian Murray <email address hidden> Tue, 27 Oct 2015 16:09:47 -0700

Changed in ubuntu-release-upgrader (Ubuntu Wily):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for ubuntu-release-upgrader has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Thanks for fixing this. Maybe I'm misunderstanding this, but shouldn't this be released into vivid repositories to handle updates from vivid to wily?

Brian Murray (brian-murray) wrote :

The way the release upgrade process works is that it downloads a tarball from the next release we can see this in the meta-release file.

Dist: wily
Name: Wily Werewolf
Version: 15.10
Date: Thu, 22 October 2015 15:10:00 UTC
Supported: 1
Description: This is the 15.10 release
Release-File: http://archive.ubuntu.com/ubuntu/dists/wily/Release
ReleaseNotes: http://archive.ubuntu.com/ubuntu/dists/wily-updates/main/dist-upgrader-all/current/ReleaseAnnouncement
ReleaseNotesHtml: http://archive.ubuntu.com/ubuntu/dists/wily-updates/main/dist-upgrader-all/current/ReleaseAnnouncement.html
UpgradeTool: http://archive.ubuntu.com/ubuntu/dists/wily-updates/main/dist-upgrader-all/current/wily.tar.gz
UpgradeToolSignature: http://archive.ubuntu.com/ubuntu/dists/wily-updates/main/dist-upgrader-all/current/wily.tar.gz.gpg

So when the upgrade from Vivid to Wily is performed, we download the version of ubuntu-release-upgrader from wily. Subsequently, the fix only needs to appear in the release to which the upgrade is being performed.

Having said that it's likely Vivid does need a fix for upgrades from Trusty, but this is currently untestable because of bug 1497688.

zob (zob) wrote :

I see. Thank you for taking your time to explain this, Brian.

summary: - new kernel removed after upgrade if linux meta package not installed
+ new kernel not installed during upgrade if linux meta package not
+ installed
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers